void zobrazCislo (int cislo)
{ //Funkce zobrazí číslo na Saimon1
  digitalWrite(2,cislo&1);
  digitalWrite(3,cislo&2);
  digitalWrite(4,cislo&4);
  digitalWrite(5,cislo&8);
}
void zobrazCisloSaimon2 (int cislo2)
{ //Funkce zobrazí číslo na Saimon1
  digitalWrite(6,cislo2&1);
  digitalWrite(7,cislo2&2);
  digitalWrite(8,cislo2&4);
  digitalWrite(9,cislo2&8);
}

void setup() {
  
  int krok;
  int odpocet, rychlostOdpoctu, potenciometr, kodBomby; 
  int pin = 2;
  do 
  { //Zde se nastaví zdířky D02 až D09 jako OUTPUT
    pinMode(pin++,OUTPUT);  
  } while (pin<=9);
  pinMode (10,INPUT); //zde je připojené tlačítko pro deaktivaci
  
  randomSeed (analogRead(A0)); //zapne generátor náhodných čísel
  kodBomby=random (0,16) ; //vygeneruje náhodný kod pro deaktivaci
  odpocet=15; 
  rychlostOdpoctu=10; //defunuje, jak rychle bomba odpočítává
  do
    {
      zobrazCislo(odpocet);
      tone(10,500,10); //tikání
      for (krok=0;krok<100;krok++)
      { //v tomto cyklu stále čteme hodnotu
        //potenciometru a porovnáváme, zda
        //bylo stisknuté tlačítko
        potenciometr=analogRead (A7)/64;
        zobrazCisloSaimon2 (potenciometr);
        if (digitalRead (11))
        { //pokud bylo stisknuté
          if (potenciometr==kodBomby)
          { //a našli jsme správný kod, hra končí
            tone (10,500,100);
            delay(100);
            tone (10,750,100);
            delay(100);
            exit(0);
          }
          else 
          { //pokud jsme zadali neslrávný kod, zrychlí se odpočet
            //který ale nesmí být roven nule
            if ( rychlostOdpoctu > 1 )rychlostOdpoctu--;
            delay(100);
          }
        }
      delay(rychlostOdpoctu);  
      }
      odpocet=odpocet-1;
    } while(odpocet>=0);

    //pokud je odpočet na nule, uděláme zvuk výbuchu
    //a hra také končí
    for (krok=2000;krok>100;krok=krok-10) 
    {
      tone (10,krok,10);
      delay (20);
    }
}


void loop() {
}
