
int zvuknepritel;
int smrtnepritel;
int score;
int zvukstrely;
int tanky,tankx;
int strelaAktivni,ystrela,xstrela, rychlostStrely;
int xnepritel, ynepritel, nepritelAktivni, rychlostNepritel;
int nahodneCislo;
int pocetZivotu, rychlostNepritelPuvodni, scorePuvodni;
#include "LedControl.h"
LedControl obrazovka=LedControl(12,11,10,1);

void setup() {
obrazovka.shutdown (0,false);
obrazovka.setIntensity(0,8);
obrazovka.clearDisplay(0);
pinMode (2,INPUT);
strelaAktivni=0;
rychlostStrely=3;
randomSeed(A0);
ynepritel=0;
xnepritel=random(0,6);
nepritelAktivni=1;
rychlostNepritelPuvodni=10;
rychlostNepritel=rychlostNepritelPuvodni;
scorePuvodni=8;
score=scorePuvodni;
pinMode(4,OUTPUT);
pinMode(5,OUTPUT);
pinMode(6,OUTPUT);
pinMode(7,OUTPUT);
}
void zobrazscore(int cislo)

{
  digitalWrite(4,cislo&1);
  digitalWrite(5,cislo&2);
  digitalWrite(6,cislo&4);
  digitalWrite(7,cislo&8);
}

void zobrazTank (int x, int y )
{
  obrazovka.setLed(0,y+0,x+1,1); //tohle zobrazí tank
  obrazovka.setLed(0,y+1,x+0,1);
  obrazovka.setLed(0,y+1,x+1,1);
  obrazovka.setLed(0,y+1,x+2,1);
}

void prekresliTank (int x, int y )
{
  obrazovka.setLed(0,y+0,x+1,0); //překreslíme tank
  obrazovka.setLed(0,y+1,x+0,0);
  obrazovka.setLed(0,y+1,x+1,0);
  obrazovka.setLed(0,y+1,x+2,0); 
}

void loop() {
tanky=6;
zobrazscore(score);
if (score==0)
{
  int time=100;
  tone ( 3, 262, time);
  delay (time);
  tone ( 3, 294, time);
  delay (time);
  tone ( 3, 330, time);
  delay (time);
  tone ( 3, 349, time);
  delay (time);
  tone ( 3, 392, time);
  delay (time);
  tone ( 3, 440, time);
  delay (time);
  tone ( 3, 494, time);
  delay (time);
  tone ( 3, 523, time);
  delay (time);
  strelaAktivni=0;
  rychlostStrely=3;
  randomSeed(A0);
  ynepritel=0;
  xnepritel=random(0,6);
  nepritelAktivni=1;
  rychlostNepritelPuvodni--;
  if (rychlostNepritelPuvodni<4)rychlostNepritelPuvodni=4;
  score=++scorePuvodni;
  if (score>15) exit(0);
}
tankx=analogRead(A7)/100;  //čteme pozici potenciometru pro pohyb tanku 
tankx--; //aby mohl vyjet z částečně z okraje


if (tankx>6) tankx=6; //nesmí být větší jak šest, aby nevyjel z obrazovky

zobrazTank (tankx, tanky);


if (digitalRead(2)==1)  //pokud stiskneme tlačítko
if (strelaAktivni==0)  //a pokud neni střela aktivní
{
  strelaAktivni=1;  //nastavíme počáteční souřadnice střely a spustíme ji
  ystrela=6;
  xstrela=tankx+1;
  zvukstrely=1999;
}
if (strelaAktivni==1) //pokud jsme vystřelili, zobrazíme střelu
{
     obrazovka.setLed (0,ystrela,xstrela,1); 
     if (xnepritel==xstrela) //zde se porovná, jestli jsme střelou trefili 
       if (ynepritel==ystrela)
       { //pokud ano
        strelaAktivni=0; //zruší to střelu
        nepritelAktivni=0; //a zruší to nepřítele
        //rychlostNepritel--;
        xnepritel=-1;
        ynepritel=-1;
        obrazovka.setLed (0,ystrela,xstrela,0); //smaže střelu z obrazovky
        //zde můžeme dopsat zvuk zničení nepřítele a začít počítat skóre
        score--;
     
          smrtnepritel=100;
          zvuknepritel=350;
       }
}
if (nepritelAktivni==1)
{
     obrazovka.setLed (0,ynepritel,xnepritel,1); //pokud je na obrazovce nepřítel, nakreslíme ho
}



delay(25); //tohle je hlaní rychlost hry

if (smrtnepritel>0)
{
  smrtnepritel=smrtnepritel-8;
  tone(3,zvuknepritel,8);
  zvuknepritel=zvuknepritel+10;
}

if (strelaAktivni==1) //pokud jsme vystřelili, pohybujeme střelou, dokud nevyletí z obrazovky
{
     obrazovka.setLed (0,ystrela,xstrela,0); //tohle posune střelu o krok dál
     rychlostStrely--; //tohle zpomaluje střelu, dá se nastavovat rychlost
     if (rychlostStrely==0)
     {
        ystrela--;
        zvukstrely=zvukstrely-100;
        rychlostStrely=3; 
     }

     if (ystrela<0) //pokud střela vyletěla z obrazovky, deaktivujeme ji
     {
        strelaAktivni=0;
     }
     //zde můžeme dodělat zvuk střely
     tone(3,zvukstrely,2);
     
}
if (nepritelAktivni==1)
{
     obrazovka.setLed (0,ynepritel,xnepritel,0); 
     if (ynepritel==tanky)
     if (xnepritel>=(tankx) )
     if (xnepritel<=(tankx+2) )
     {
      int y=0;
      int x=0;
      int zvuk;
      zvuk=1000;
      do
      {
        x=0;
        do
        {
          obrazovka.setLed (0,y,x,1);
          x++;
          tone (3,zvuk,10);
          zvuk=zvuk-10;
          delay (10);
        }while(x<8);
        y++;
      }while(y<8);
      
      exit (0);
      
      
     }
     rychlostNepritel--; //tohle určuje rychlost nepřítele
     if (rychlostNepritel<=0)
     {
        ynepritel++;
        rychlostNepritel=rychlostNepritelPuvodni; 
     }

     if (ynepritel==7) //pokud nepřítel vyletěl z obrazovky, deaktivujeme ho
     {
        nepritelAktivni=0;
     }
}
if (nepritelAktivni==0)
if (smrtnepritel<=0)
{
    //zde je třeba dopsat program tak, aby se nepřítel znovu objevil
    ynepritel=0;
    if (random(0,30)==10) nepritelAktivni=1;
    xnepritel=random(0,8);

  
}

//dál můžeme zobrazovat počet životů a měnit ho, když nás nepřítel zasáhne


prekresliTank( tankx, tanky );
}
